package dev.pfaff.altargui.widgets;

import dev.pfaff.altargui.StateContext;
import dev.pfaff.altargui.Widget;
import dev.pfaff.altargui.WidgetInstance;
import dev.pfaff.altargui.WidgetInstantiationArgs;
import dev.pfaff.altargui.element.SingleChildWidgetInstance;
import dev.pfaff.altargui.element.CustomLayoutSingleChildWidgetInstance;
import org.jetbrains.annotations.MustBeInvokedByOverriders;
import org.jetbrains.annotations.NotNull;

public interface SingleChildWidget extends Widget {
    Widget child();

    @Override
    default @NotNull WidgetInstance<? extends SingleChildWidget> instantiate(WidgetInstantiationArgs args) {
        return new AutoLayoutState<>(args);
    }

    static abstract class CustomLayoutState<W extends SingleChildWidget> extends CustomLayoutSingleChildWidgetInstance<W> {
        protected CustomLayoutState(WidgetInstantiationArgs args) {
            super(args);
        }

        @Override
        @MustBeInvokedByOverriders
        public void configure(StateContext stateContext, W widget, boolean init) {
            setChild(stateContext, widget.child());
        }
    }

    static class AutoLayoutState<W extends SingleChildWidget> extends SingleChildWidgetInstance<W> {
        protected AutoLayoutState(WidgetInstantiationArgs args) {
            super(args);
        }

        @Override
        @MustBeInvokedByOverriders
        public void configure(StateContext stateContext, W widget, boolean init) {
            setChild(stateContext, widget.child());
        }
    }
}
